package com.gmail.romanesco2090.role;

import java.util.LinkedList;
import java.util.List;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;

import com.gmail.romanesco2090.TalkFactory;
import com.gmail.romanesco2090.base.BaseRole;
import com.gmail.romanesco2090.data.GameResult;
import com.gmail.romanesco2090.util.Debug;
import com.gmail.romanesco2090.util.Gadget;
import com.gmail.romanesco2090.util.RandomSelect;

public class Bodyguard extends BaseRole {

	public Bodyguard(GameResult gameResult) {
		super(gameResult);
	}

	/** 護衛対象エージェント */
	protected Agent guardingTarget;

	/** 護衛対象エージェントリスト */
	protected List<Agent> guardingCandidate;

	protected Agent guardedAgent;

	protected List<Agent> whiteList;

	protected boolean guardSeerFlg;

	protected boolean guardMediumFlg;

	/** 前日生きていたエージェントリスト */
	protected List<Agent> lastAliveAgentList;

	@Override
	public void initializeAction15() {
		guardingTarget = null;
		guardingCandidate = getAliveOthersList();
		guardedAgent = null;
		whiteList = new LinkedList<>();
		guardSeerFlg = true;
		guardMediumFlg = true;
		lastAliveAgentList = getAliveOthersList();
	}

	@Override
	public void dayStartAction15() {
		Agent executedAgent = gameInfo.getExecutedAgent();
		Agent attackedAgent = null;

		List<Agent> deadAgents = new LinkedList<>();

		deadAgents = Gadget.remainList(lastAliveAgentList, getAliveOthersList());
		if (executedAgent != null) {
			deadAgents.remove(executedAgent);
		}
		attackedAgent = RandomSelect.get(deadAgents);

		if (attackedAgent != null) {
			if (comingoutMap.containsKey(attackedAgent)) {
				if (comingoutMap.get(attackedAgent) == Role.SEER) {
					guardSeerFlg = false;
				}
				if (comingoutMap.get(attackedAgent) == Role.MEDIUM) {
					guardMediumFlg = false;
				}
			}
		} else if (gameInfo.getDay() >= 2 && attackedAgent == null) {
			guardingTarget = guardedAgent;
			Debug.error(guardingTarget+"を守り続ける！！！！！");
		}

		lastAliveAgentList = getAliveOthersList();
	}

	@Override
	public void updateAction15() {
	}

	@Override
	public void talkAction15() {
		if (turn == 3 || turn == 5 || turn == 7) {
			votingCandidate = decideCnaditate(calculateVotedScore(talkMap, voteCountMap));
			votingTarget = RandomSelect.getOP(gameResult.winMap, votingCandidate);
			myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
		}
	}

	@Override
	public Agent voteAction15() {
		if (votingTarget != null) {
			return votingTarget;
		} else if (!votingCandidate.isEmpty()) {
			return RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
		} else {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		}
	}

	@Override
	public Agent guardAction() {
		if (guardSeerFlg) {
			for (Agent agent : comingoutMap.keySet()) {
				if (comingoutMap.get(agent) == Role.SEER && getAliveOthersList().contains(agent)) {
					guardingCandidate.clear();
					guardingCandidate.add(agent);
				}
			}
		} else if (guardMediumFlg) {
			for (Agent agent : comingoutMap.keySet()) {
				if (comingoutMap.get(agent) == Role.MEDIUM && getAliveOthersList().contains(agent)) {
					guardingCandidate.clear();
					guardingCandidate.add(agent);
				}
			}
		}

		if (guardingTarget != null && getAliveOthersList().contains(guardingTarget)) {
			guardedAgent = guardingTarget;
			return guardingTarget;
		} else if (!guardingCandidate.isEmpty()) {
			guardedAgent = RandomSelect.get(guardingCandidate);
			return guardedAgent;
		} else {
			guardedAgent = RandomSelect.get(getAliveOthersList());
			return guardedAgent;
		}
	}
}
