package com.gmail.romanesco2090.role;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;

import com.gmail.romanesco2090.TalkFactory;
import com.gmail.romanesco2090.base.BaseRole;
import com.gmail.romanesco2090.data.GameResult;
import com.gmail.romanesco2090.util.Gadget;
import com.gmail.romanesco2090.util.RandomSelect;

public class Possessed extends BaseRole {

	public Possessed(GameResult gameResult) {
		super(gameResult);
		// TODO 自動生成されたコンストラクター・スタブ
	}

	/** COしたかどうかのフラグ */
	protected boolean isComingouted;

	/** 人狼COフラグ */
	protected boolean isWolfCO;

	/** 占い師COしたエージェントリスト */
	List<Agent> seerCOList;

	/** ニセ占ったエージェントマップ */
	protected Map<Agent, Species> divinedMap;

	@Override
	public void initializeAction() {
		isComingouted = false;
		isWolfCO = false;
		seerCOList = new LinkedList<>();
	}

	@Override
	public void updateAction() {
	}

	@Override
	public void dayStartAction() {
	}

	@Override
	public void talkAction() {
		if (gameInfo.getDay() == 1) {
			if (!isComingouted) {
				myTalkQue.offer(TalkFactory.comingoutRemark(gameInfo.getAgent(), Role.SEER));
				isComingouted = true;
			}
			if (turn == 1) {
				if (!comingoutMap.isEmpty()) {
					for (Agent agent : comingoutMap.keySet()) {
						if (comingoutMap.get(agent) == Role.SEER) {
							seerCOList.add(agent);
						}
					}
				}
				//自分以外の占い師COが2人なら占い師CO誰かに黒出し
				if (seerCOList.size() == 2) {
					votingTarget = RandomSelect.getOP(gameResult.getWinMap(), seerCOList);
					myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				} else {
					votingTarget = RandomSelect.getOP(gameResult.getWinMap(),
							Gadget.remainList(getAliveOthersList(), seerCOList));
					myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				}
			}
		} else if (gameInfo.getDay() == 2) {
			if (!isWolfCO) {
				myTalkQue.offer(TalkFactory.comingoutRemark(gameInfo.getAgent(), Role.POSSESSED));
				myTalkQue.offer(TalkFactory.comingoutRemark(gameInfo.getAgent(), Role.WEREWOLF));
				isWolfCO = true;
			}

			List<Agent> wolfCOList = new LinkedList<>();
			if (turn == 1) {
				if (!comingoutMap.isEmpty()) {
					for (Agent agent : comingoutMap.keySet()) {
						if (comingoutMap.get(agent) == Role.WEREWOLF) {
							wolfCOList.add(agent);
						}
					}
				}
			}

			if (!seerCOList.isEmpty()) {
				if (wolfCOList.size() == 2) {
					myTalkQue.offer(TalkFactory.comingoutRemark(gameInfo.getAgent(), Role.POSSESSED));
				}
				votingCandidate = Gadget.remainList(seerCOList, wolfCOList);
			} else {
				votingCandidate = getAliveOthersList();
				votingCandidate = Gadget.remainList(votingCandidate, wolfCOList);
			}
		}
	}

	@Override
	public Agent voteAction() {
		if (votingTarget != null) {
			return votingTarget;
		} else if (!votingCandidate.isEmpty()) {
			return RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
		} else {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		}
	}

	@Override
	public void finishAction() {
	}

	@Override
	public void initializeAction15() {
		isComingouted = false;
		divinedMap = new HashMap<>();
	}

	@Override
	public void updateAction15() {
		// TODO 自動生成されたメソッド・スタブ
	}

	@Override
	public void dayStartAction15() {
		// TODO 自動生成されたメソッド・スタブ
		super.dayStartAction15();
	}

	@Override
	public void talkAction15() {
		List<Agent> seerList = new LinkedList<>();
		List<Agent> mediumList = new LinkedList<>();
		for (Agent agent : comingoutMap.keySet()) {
			if (getAliveOthersList().contains(agent) && comingoutMap.get(agent) == Role.SEER) {
				seerList.add(agent);
			} else if (getAliveOthersList().contains(agent) && comingoutMap.get(agent) == Role.MEDIUM) {
				mediumList.add(agent);
			}
		}
		//発話処理
		//1日0ターン目は占い師CO
		if (!isComingouted) {
			myTalkQue.add(TalkFactory.comingoutRemark(gameInfo.getAgent(), Role.SEER));
			isComingouted = true;
		}
		if (gameInfo.getDay() == 1) {
			if (turn == 1) {
				if (!seerList.isEmpty()) {
					votingTarget = RandomSelect.getOP(gameResult.winMap, seerList);
					myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
					divinedMap.put(votingTarget, Species.WEREWOLF);
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				} else if (!mediumList.isEmpty()) {
					votingTarget = RandomSelect.getOP(gameResult.winMap, mediumList);
					myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
					divinedMap.put(votingTarget, Species.WEREWOLF);
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				} else {
					votingTarget = RandomSelect.getOP(gameResult.winMap, getAliveOthersList());
					myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
					divinedMap.put(votingTarget, Species.WEREWOLF);
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				}
			}
		} else {
			if (turn == 0) {
				if (!seerList.isEmpty()) {
					votingTarget = RandomSelect.getOP(gameResult.winMap, seerList);
					myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
					divinedMap.put(votingTarget, Species.WEREWOLF);
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				} else if (!mediumList.isEmpty()) {
					votingTarget = RandomSelect.getOP(gameResult.winMap, mediumList);
					myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
					divinedMap.put(votingTarget, Species.WEREWOLF);
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				} else {
					votingTarget = RandomSelect.getOP(gameResult.winMap, getAliveOthersList());
					myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
					divinedMap.put(votingTarget, Species.WEREWOLF);
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				}
			}
		}
	}

	@Override
	public Agent voteAction15() {
		if (votingTarget != null) {
			return votingTarget;
		} else if (!votingCandidate.isEmpty()) {
			return RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
		} else {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		}
	}

	@Override
	public void finishAction15() {
		// TODO 自動生成されたメソッド・スタブ
		super.finishAction15();
	}

}
