package com.gmail.romanesco2090.role;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;

import com.gmail.romanesco2090.TalkFactory;
import com.gmail.romanesco2090.base.BaseRole;
import com.gmail.romanesco2090.data.GameResult;
import com.gmail.romanesco2090.util.Gadget;
import com.gmail.romanesco2090.util.RandomSelect;

public class Seer extends BaseRole {

	/** 占うエージェントリスト */
	protected List<Agent> diviningList;

	/** 占ったエージェントマップ */
	protected Map<Agent, Species> divinedMap;

	/** COしたかどうかのフラグ */
	protected boolean isComingouted;

	/** 人狼COフラグ */
	protected boolean isWolfCO;

	/** 本日の占い結果 */
	protected Judge todayJudge;

	/** 自分が占う候補者 */
	protected List<Agent> diviningCandidate;

	/** 次の日の占い対象エージェント */
	protected Agent diviningTarget;

	public Seer(GameResult gameResult) {
		super(gameResult);
	}

	@Override
	public void initializeAction() {
		diviningList = new LinkedList<>();
		divinedMap = new HashMap<>();
		isComingouted = false;
		isWolfCO = false;
		todayJudge = null;
	}

	@Override
	public void updateAction() {

	}

	@Override
	public void dayStartAction() {
		todayJudge = gameInfo.getDivineResult();
		if (todayJudge != null) {
			divinedMap.put(todayJudge.getTarget(), todayJudge.getResult());
		}
	}

	@Override
	public void talkAction() {
		if (todayJudge != null) {
			//占い対象が人間かどうか
			boolean isHuman = false;
			//自分以外の占い師COの数
			int seerCONo = 0;
			if (todayJudge.getResult() == Species.HUMAN) {
				isHuman = true;
			}

			for (Agent agent : comingoutMap.keySet()) {
				if (comingoutMap.get(agent) == Role.SEER) {
					seerCONo++;
				}
			}

			//発話処理
			//1日0ターン目は占い師CO
			if (!isComingouted) {
				myTalkQue.add(TalkFactory.comingoutRemark(gameInfo.getAgent(), Role.SEER));
				isComingouted = true;
			}
			//1日目の動き
			//占い師COが自分のみの時
			if (gameInfo.getDay() == 1 && turn == 1 && seerCONo == 0) {
				if (isHuman) {
					//占い対象に白出し発言
					myTalkQue.offer(
							TalkFactory.divinedResultRemark(todayJudge.getTarget(),
									todayJudge.getResult()));
					//占った人を除外して適当に発言投票
					votingTarget = RandomSelect.getOP(gameResult.getWinMap(),
							Gadget.remainList(getAliveOthersList(), divinedMap.keySet()));
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				} else {
					//占い対象に黒出し発言
					myTalkQue.offer(TalkFactory.divinedResultRemark(todayJudge.getTarget(),
							todayJudge.getResult()));
					//占い対象に投票発言
					myTalkQue.offer(TalkFactory.voteRemark(todayJudge.getTarget()));
					//投票発言
					votingTarget = todayJudge.getTarget();
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				}
			}
			//占い師COが自分ともう一人の時
			else if (gameInfo.getDay() == 1 && turn == 1 && seerCONo == 1) {
				//占い結果白の時
				if (isHuman) {
					//占い対象が占い師COの時
					if (comingoutMap.containsKey(todayJudge.getTarget())) {
						if (comingoutMap.get(todayJudge.getTarget()) == Role.SEER) {
							List<Agent> tmpList = new LinkedList<>();
							for (Agent agent : comingoutMap.keySet()) {
								tmpList.add(agent);
							}
							tmpList.remove(todayJudge.getTarget());
							votingTarget = RandomSelect.getOP(gameResult.getWinMap(), tmpList);
							myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
							myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
						}
						//占い対象が占い師COしていない時
					} else {
						for (Agent agent : comingoutMap.keySet()) {
							if (comingoutMap.get(agent) == Role.SEER) {
								votingCandidate.add(agent);
							}
						}
						votingTarget = RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
						myTalkQue.offer(TalkFactory.divinedResultRemark(votingTarget, Species.WEREWOLF));
						myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
					}
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				}
				//占い結果黒の時
				else {
					//占い対象に黒出し発言
					myTalkQue.offer(TalkFactory.divinedResultRemark(todayJudge.getTarget(),
							todayJudge.getResult()));
					//占い対象に投票発言
					myTalkQue.offer(TalkFactory.voteRemark(todayJudge.getTarget()));
					//投票発言
					votingTarget = todayJudge.getTarget();
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				}
			}
			//占い師COが自分含め3人の時
			else if (gameInfo.getDay() == 1 && turn == 1 && seerCONo == 2) {
				if (isHuman) {
					//自分以外の占い師COした人
					List<Agent> seerCOList = new LinkedList<>();
					for (Agent agent : getAliveOthersList()) {
						if (comingoutMap.containsKey(agent)) {
							if (comingoutMap.get(agent) == Role.SEER) {
								seerCOList.add(agent);
							}
						}
					}
					//占い対象に白出し発言
					myTalkQue.offer(
							TalkFactory.divinedResultRemark(todayJudge.getTarget(),
									todayJudge.getResult()));
					//占い師COのどちらかに投票発言
					votingTarget = RandomSelect.getOP(gameResult.getWinMap(),
							Gadget.remainList(seerCOList, divinedMap.keySet()));
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				} else {
					//占い対象に黒出し発言
					myTalkQue.offer(TalkFactory.divinedResultRemark(todayJudge.getTarget(),
							todayJudge.getResult()));
					//占い対象に投票発言
					myTalkQue.offer(TalkFactory.voteRemark(todayJudge.getTarget()));
					//投票発言
					votingTarget = todayJudge.getTarget();
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				}
			}
			//2日目
			else if (gameInfo.getDay() == 2) {
				if (!isWolfCO) {
					myTalkQue.add(TalkFactory.comingoutRemark(gameInfo.getAgent(), Role.WEREWOLF));
					isWolfCO = true;
				}
				if (turn == 1) {
					votingCandidate = getAliveOthersList();
					for (Agent agent : comingoutMap.keySet()) {
						if (comingoutMap.get(agent) == Role.SEER) {
							votingCandidate.remove(agent);
						}
					}
					votingTarget = RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
					if (todayJudge.getResult() == Species.WEREWOLF) {
						votingTarget = todayJudge.getTarget();
					} else if (!votingCandidate.isEmpty()) {
						votingTarget = RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
					}
					myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
				}
			}
		}
	}

	@Override
	public Agent voteAction() {
		if (votingTarget != null) {
			return votingTarget;
		} else if (!votingCandidate.isEmpty()) {
			return RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
		} else {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		}
	}

	@Override
	public Agent divineAction() {
		//0日目は勝率が最も高い人からランダムに選択
		if (gameInfo.getDay() == 0) {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		} else if (gameInfo.getDay() == 1) {
			//2日目は占い師COを占う
			List<Agent> aliveSeerCOList = new LinkedList<>();
			for (Agent agent : getAliveOthersList()) {
				if (comingoutMap.containsKey(agent)) {
					aliveSeerCOList.add(agent);
				}
			}
			return RandomSelect.getOP(gameResult.getWinMap(), Gadget.remainList(aliveSeerCOList, divinedMap.keySet()));
		} else {
			//占った人を除外して生きている人を占う
			return RandomSelect.getOP(gameResult.getWinMap(),
					Gadget.remainList(getAliveOthersList(), divinedMap.keySet()));
		}
	}

	@Override
	public void initializeAction15() {
		diviningList = new LinkedList<>();
		divinedMap = new HashMap<>();
		isComingouted = false;
		isWolfCO = false;
		todayJudge = null;
		diviningCandidate = new LinkedList<>();
		diviningTarget = null;
	}

	@Override
	public void updateAction15() {

	}

	@Override
	public void dayStartAction15() {
		todayJudge = gameInfo.getDivineResult();
		if (todayJudge != null) {
			divinedMap.put(todayJudge.getTarget(), todayJudge.getResult());
			if (todayJudge.getResult() == Species.HUMAN) {
				if (!votingCandidate.isEmpty()) {
					if (votingCandidate.contains(todayJudge.getTarget())) {
						votingCandidate.remove(todayJudge.getTarget());
					}
				}
			}
		}
	}

	@Override
	public void talkAction15() {
		if (todayJudge.getResult() == Species.WEREWOLF || gameInfo.getDay() == 3) {
			if (!isComingouted) {
				myTalkQue.add(TalkFactory.comingoutRemark(gameInfo.getAgent(), Role.SEER));
				for (Agent agent : divinedMap.keySet()) {
					myTalkQue.offer(TalkFactory.divinedResultRemark(agent, divinedMap.get(agent)));
				}
				isComingouted = true;
			}
		}
		if (turn == 0) {
			if (isComingouted) {
				if (todayJudge != null) {
					myTalkQue.offer(TalkFactory.divinedResultRemark(todayJudge.getTarget(), todayJudge.getResult()));
					if (todayJudge.getResult() == Species.WEREWOLF) {
						votingTarget = todayJudge.getTarget();
						myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
					} else {
						votingTarget = RandomSelect.getOP(gameResult.winMap, votingCandidate);
						myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
					}
				}
			} else {
				votingTarget = RandomSelect.getOP(gameResult.winMap, votingCandidate);
				myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
			}
		}
	}

	@Override
	public Agent voteAction15() {
		if (votingTarget != null) {
			return votingTarget;
		} else if (!votingCandidate.isEmpty()) {
			return RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
		} else {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		}
	}

	@Override
	public Agent divineAction15() {
		diviningCandidate = getAliveOthersList();
		for(Agent agent: divinedMap.keySet()) {
			if(!diviningCandidate.isEmpty()) {
				if(diviningCandidate.contains(agent)) {
					diviningCandidate.remove(agent);
				}
			}
		}
		//0日目は勝率が最も高い人からランダムに選択
		if (gameInfo.getDay() == 0) {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		}
		if (diviningTarget != null) {
			return diviningTarget;
		} else if (!diviningCandidate.isEmpty()) {
			return RandomSelect.getOP(gameResult.getWinMap(), diviningCandidate);
		} else {
			return RandomSelect.get(getAliveOthersList());
		}
	}
}
