package com.gmail.romanesco2090.role;

import java.util.LinkedList;
import java.util.List;

import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;

import com.gmail.romanesco2090.TalkFactory;
import com.gmail.romanesco2090.base.BaseRole;
import com.gmail.romanesco2090.data.GameResult;
import com.gmail.romanesco2090.util.Gadget;
import com.gmail.romanesco2090.util.RandomSelect;

public class Villager extends BaseRole {

	/** 黒出しされた数 */
	protected int blackNum;

	public Villager(GameResult gameResult) {
		super(gameResult);
	}

	@Override
	public void initializeAction() {
		blackNum = 0;
	}

	@Override
	public void updateAction() {
		List<Talk> talkList = gameInfo.getTalkList();
		for (int i = readTalkNum; i < talkList.size(); i++) {
			Talk talk = talkList.get(i);
			Agent talker = talk.getAgent();
			Content content = new Content(talk.getText());
			//自分の発言には反応しない
			if (talker == gameInfo.getAgent()) {
				continue;
			}
			//占い結果発言時の処理
			if (content.getTopic() == Topic.DIVINED) {
				if (comingoutMap.containsKey(talker)) {
					if (comingoutMap.get(talker) == Role.SEER) {
						//白の時
						if (content.getResult() == Species.HUMAN) {
							if (votingCandidate.contains(content.getTarget())) {
								votingCandidate.remove(content.getTarget());
							}
						}
						//黒の時
						else {
							if (content.getTarget() != gameInfo.getAgent()
									&& !votingCandidate.contains(content.getTarget())) {
								votingCandidate.add(content.getTarget());
							}
						}
					}
				}
			}
		}
	}

	@Override
	public void dayStartAction() {
	}

	@Override
	public void talkAction() {
		int seerCO = 0;
		if (!comingoutMap.isEmpty()) {
			for (Agent agent : comingoutMap.keySet()) {
				if (comingoutMap.get(agent) == Role.SEER) {
					seerCO++;
				}
			}
		}

		//黒出し発言されたら発言する
		if (votingCandidate.size() > blackNum) {
			//占い師CO3人の時は投票対象から占い師を除く
			if (seerCO == 3) {
				List<Agent> removeAgents = new LinkedList<>();
				for (Agent agent : votingCandidate) {
					if (comingoutMap.containsKey(agent)) {
						if (comingoutMap.get(agent) != Role.SEER) {
							removeAgents.add(agent);
							//votingCandidate.remove(agent);
						}
					} else {
						removeAgents.add(agent);
						//votingCandidate.remove(agent);
					}
				}
				Gadget.remainList(votingCandidate, removeAgents);
			}

			votingTarget = RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
			myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
			blackNum = votingCandidate.size();
		}
	}

	@Override
	public Agent voteAction() {
		if (votingTarget != null) {
			return votingTarget;
		} else if (!votingCandidate.isEmpty()) {
			return RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
		} else {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		}
	}

	@Override
	public void initializeAction15() {
	}

	@Override
	public void updateAction15() {
		// TODO 自動生成されたメソッド・スタブ
	}

	@Override
	public void dayStartAction15() {
		// TODO 自動生成されたメソッド・スタブ
		super.dayStartAction15();
	}

	@Override
	public void talkAction15() {
		if (turn == 3 || turn == 5 || turn == 7) {
			votingCandidate = decideCnaditate(calculateVotedScore(talkMap, voteCountMap));
			votingTarget = RandomSelect.getOP(gameResult.winMap, votingCandidate);
			myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
		}
	}

	@Override
	public Agent voteAction15() {
		if (votingTarget != null) {
			return votingTarget;
		} else if (!votingCandidate.isEmpty()) {
			return RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
		} else {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		}
	}

}
