package com.gmail.romanesco2090.util;

import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;

public class Debug {
	/** エラー文格納リスト */
	private static List<String> passError = new ArrayList<>();

	private static boolean isDebug = false;

	/**
	 * デバック中ならば標準出力
	 * @param s
	 */
	public static <T> void print(T s) {
		if(isDebug) {
			System.out.println(s);
		}
	}

	/**
	 * デバック中ならば標準出力(エラー表示)
	 * @param s
	 */
	public static <T> void error(T s) {
		if(isDebug) {
			System.err.println(s);
		}
	}

	/**
	 * エラー文をリストにためる
	 * @param sw 表示文
	 */
	public static void stackError(StringWriter sw) {
		passError.add(sw.toString());
	}

	/**
	 * 確認できたエラーを表示
	 */
	public static void showError() {
		for(int i = 0; i < passError.size(); i++) {
			System.out.println(passError.get(i));
		}
	}


}
